apiVersion: {{ sts_apivers }}
kind: StatefulSet
metadata:
  labels:
{% if do_backups %}
    backups.opsperator.io/driver: cassandra
    backups.opsperator.io/cqlshversion: FIXME
{% if (backups_interval | default('daily')) == 'hourly' %}
    backups.opsperator.io/interval: hourly
    backups.opsperator.io/preferredtime: "{{ backups_hourly_start_minute | default(15)}}"
{% elif (backups_interval | default('daily')) == 'weekly' %}
    backups.opsperator.io/interval: weekly
    backups.opsperator.io/preferredtime: "{{ backups_weekly_start_day | default(0) }}"
{% else %}
    backups.opsperator.io/interval: daily
    backups.opsperator.io/preferredtime: "{{ backups_daily_start_hour | default(2) }}"
{% endif %}
{% endif %}
{% if pki_set | length > 0 %}
    pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    {{ network_policy_deployment_label }}: {{ cassandra_name }}
  name: {{ cassandra_name }}
  namespace: {{ namespace }}
spec:
  podManagementPolicy: OrderedReady
  replicas: {{ cassandra_replicas }}
  selector:
    matchLabels:
      name: {{ cassandra_name }}
  serviceName: {{ cassandra_name }}
  template:
    metadata:
      labels:
        name: {{ cassandra_name }}
{% if pki_set | length > 0 %}
        pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    spec:
{% if do_affinities | default(True) %}
      affinity:
        podAntiAffinity:
{% if scheduling_affinity_required %}
          requiredDuringSchedulingIgnoredDuringExecution:
          - labelSelector:
              matchExpressions:
              - key: name
                operator: In
                values: [ {{ cassandra_name }} ]
            topologyKey: {{ k8s_affinity_zone_label }}
{% else %}
          preferredDuringSchedulingIgnoredDuringExecution:
          - podAffinityTerm:
              labelSelector:
                matchExpressions:
                - key: name
                  operator: In
                  values: [ {{ cassandra_name }} ]
              topologyKey: {{ k8s_affinity_zone_label }}
            weight: 42
{% endif %}
{% endif %}
      automountServiceAccountToken: false
      containers:
      - env:
        - name: CASSANDRA_CLUSTER_NAME
          value: {{ cassandra_cluster_name | default('sweet') }}
        - name: CASSANDRA_DC
          value: {{ cassandra_dc | default('DC1') }}
        - name: CASSANDRA_HOSTNAME
          valueFrom:
            fieldRef:
              fieldPath: metadata.name
        - name: CASSANDRA_RACK
          value: {{ cassandra_rack | default('RACK1') }}
        - name: CASSANDRA_REPLICATION_FACTOR
          value: {{ cassandra_replicas_factor | default(1 if (cassandra_replicas | int == 1) else ((cassandra_replicas | int) - 1)) }}
        - name: DEBUG
          value: "{% if do_debugs %}yay{% endif %}"
        - name: HEAP_NEWSIZE
          value: {{ cassandra_new_heap_size | default('64M') }}
        - name: MAX_HEAP_SIZE
          value: {{ cassandra_max_heap_size | default('256M') }}
        - name: POD_IP
          valueFrom:
            fieldRef:
              fieldPath: status.podIP
        - name: TZ
          value: {{ timezone }}
        image: {{ (opsimages | json_query("[?name=='cassandra'].image"))[0] }}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
{% if k8s_flavor == 'openshift' and ocp_major in [ 3, '3' ] %}
          failureThreshold: 38
{% else %}
          failureThreshold: 5
{% endif %}
          initialDelaySeconds: 30
          periodSeconds: 15
          tcpSocket:
            port: 9042
          timeoutSeconds: 5
        name: cassandra
        ports:
        - name: cql-port
          containerPort: 9042
        - name: thift-port
          containerPort: 9160
        - name: intra-node
          containerPort: 7000
        - name: tls-intra
          containerPort: 7001
        readinessProbe:
          exec:
            command:
            - /bin/sh
            - -i
            - -c
            - /is_ready.sh
          initialDelaySeconds: 40
          periodSeconds: 30
          timeoutSeconds: 20
        resources:
          limits:
            cpu: "{{ cpu_limit }}"
            memory: "{{ memory_limit }}"
          requests:
            cpu: "{{ cpu_limit }}"
            memory: "{{ memory_limit }}"
{% if not (k8s_flavor == 'openshift' and ocp_major in [ 3, '3' ]) %}
        startupProbe:
          failureThreshold: 38
          initialDelaySeconds: 30
          periodSeconds: 15
          tcpSocket:
            port: 9042
          timeoutSeconds: 5
{% endif %}
        volumeMounts:
        - mountPath: /var/lib/cassandra/data
          name: data
{% if do_exporters %}
        image: {{ (opsimages | json_query("[?name=='csdexporter'].image"))[0] }}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
{% if k8s_flavor == 'openshift' and ocp_major in [ 3, '3' ] %}
          failureThreshold: 38
{% else %}
          failureThreshold: 5
{% endif %}
          initialDelaySeconds: 30
          periodSeconds: 30
          tcpSocket:
            port: 9113
          timeoutSeconds: 20
        name: exporter
        ports:
        - containerPort: 9113
        resources:
          limits:
            cpu: "{{ exporter_cpu_limit }}"
            memory: "{{ exporter_memory_limit }}"
          requests:
{% if ensure_dbs_has_guaranteed_qosclass | default(True) %}
            cpu: "{{ exporter_cpu_limit }}"
            memory: "{{ exporter_memory_limit }}"
{% else %}
            cpu: "{{ exporter_cpu_request }}"
            memory: "{{ exporter_memory_request }}"
{% endif %}
{% if not (k8s_flavor == 'openshift' and ocp_major in [ 3, '3' ]) %}
        startupProbe:
          failureThreshold: 38
          initialDelaySeconds: 30
          periodSeconds: 30
          tcpSocket:
            port: 9113
          timeoutSeconds: 20
{% endif %}
{% endif %}
{% if k8s_resource_nodes_selectors | length > 0 %}
      nodeSelector:
{% for sel in k8s_resource_nodes_selectors %}
        {{ sel.split('=')[0] }}: "{{ sel.split('=')[1] if (sel.split('=') | length > 1) else '' }}"
{% endfor %}
{% endif %}
{% if k8s_flavor == 'kubernetes' or (k8s_flavor == 'openshift' and ocp_major in [ 4, '4' ]) %}
      priorityClassName: opsperator-database
{% endif %}
{% if rwo_needs_fsgroup | default(False) %}
      securityContext:
        fsGroup: {{ rwo_needs_fsgroup }}
{% endif %}
      terminationGracePeriodSeconds: {{ cassandra_termination_timeout | default(600) }}
{% if do_topology_spread_constraints | default(False) %}
      topologySpreadConstraints:
      - labelSelector:
          matchLabels:
            name: {{ cassandra_name }}
        maxSkew: {{ topology_spread_max_skew | default(1) }}
        topologyKey: {{ k8s_affinity_zone_label }}
{% if scheduling_affinity_required %}
        whenUnsatisfiable: DoNotSchedule
{% else %}
        whenUnsatisfiable: ScheduleAnyway
{% endif %}
{% endif %}
  updateStrategy:
    type: RollingUpdate
  volumeClaimTemplates:
  - metadata:
      name: data
    spec:
      accessModes: [ ReadWriteOnce ]
      resources:
        requests:
          storage: "{{ cassandra_data_capacity }}"
{% if rwo_storage is defined %}
      storageClassName: {{ rwo_storage }}
{% endif %}
